/*
 * CommunicationGraph.java
 *
 * Created on 30. November 2000, 21:22
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */

public class CommunicationGraph extends Object {
  public int dimension = 0;
  public boolean[][] adjacenceMatrix = null;
  /** Creates new CommunicationGraph */
  public CommunicationGraph() {
  }
  
  public CommunicationGraph(int n) {
    adjacenceMatrix = new boolean[n][n];
    dimension = n;
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        adjacenceMatrix[i][j] = false;
      }
    }
  }
  
  public void addBidirectionalConnection(int i, int j) {
    adjacenceMatrix[i][j] = true;
    adjacenceMatrix[j][i] = true;
  }
  
  public void addUnidirectionalConnection(int i, int j) {
    adjacenceMatrix[i][j] = true;
  }
  
  public boolean test(Koord k) {
    return adjacenceMatrix[k.x][k.y];
  }
  
  public void set(Koord k) {
    adjacenceMatrix[k.x][k.y] = true;
  }

  public void unset(Koord k) {
    adjacenceMatrix[k.x][k.y] = false;
  }
}