/*
 * SimSystem.java
 *
 * Created on 28. November 2000, 20:53
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */

import java.awt.*;
import java.util.*;

import sysPr.*;

public class GraphLayout extends Object {
  GraphLayoutManager slm;
  GraphNode[] myNodes;
  Algorithm algorithm;
  int count;            // counts teh number of outgoing messages
  NormVec nv;
  double defaultlength = 30;
  double spitzen_faktor = 0.8;
  double dist_faktor = 0.2;
  Color mycolor = Color.blue;
  /** Creates new SimSystem
  */
  
  public GraphLayout(Algorithm a) {
    // Instantiating GraphLayout
    algorithm = a;
    myNodes = new GraphNode[a.getNumberOfNodes()];
    for (int i = 0; i < a.getNumberOfNodes(); i++) {
      myNodes[i] = new GraphNode(i);
    }

    slm = new GraphLayoutManager(a);
  }
  
  public void doLayout() {
    slm.layout(myNodes);
  }

  public void paint(Graphics g) {
    CommunicationGraph cg = algorithm.getCommunicationGraph();
    // draw edges
    for (int i = 0; i < cg.dimension; i++) {
      for (int j = 0; j < i; j++) {
        if (cg.adjacenceMatrix[i][j] && cg.adjacenceMatrix[j][i]) {
          GraphNode a = myNodes[i];
          GraphNode b = myNodes[j];
          Koord ka = new Koord (a.mykoord.x + a.getdim().x/2, a.mykoord.y + a.getdim().y/2);
          Koord kb = new Koord (b.mykoord.x + b.getdim().x/2, b.mykoord.y + b.getdim().y/2);
          g.setColor(Color.black);
          g.drawLine(ka.x, ka.y, kb.x, kb.y);
        }
      }
      for (int j = 0; j < cg.dimension; j++) {
        if (cg.adjacenceMatrix[i][j] && !cg.adjacenceMatrix[j][i]) {
          GraphNode a = myNodes[i];
          GraphNode b = myNodes[j];
          Koord ka = new Koord (a.mykoord.x + a.getdim().x/2, a.mykoord.y + a.getdim().y/2);
          Koord kb = new Koord (b.mykoord.x + b.getdim().x/2, b.mykoord.y + b.getdim().y/2);
          Koord km = new Koord((ka.x + kb.x) / 2, (ka.y + kb.y) / 2);
          nv = new NormVec(ka, km);
          Koord kh = new Koord((int)(km.x - nv.x * 10), (int)(km.y - nv.y * 10));
          Koord spitze1 = new Koord((int) ( nv.y * defaultlength * dist_faktor) + kh.x,
                              (int) (-nv.x * defaultlength * dist_faktor) + kh.y);
          Koord spitze2 = new Koord((int) (-nv.y * defaultlength * dist_faktor) + kh.x,
                              (int) ( nv.x * defaultlength * dist_faktor) + kh.y);
          g.setColor(Color.black);
          g.drawLine(ka.x, ka.y, kb.x, kb.y);
          g.drawLine(spitze1.x, spitze1.y, km.x, km.y);
          g.drawLine(spitze2.x, spitze2.y, km.x, km.y);
        }
      }
      
    }
    // draw nodes
    for (int i = 0; i < algorithm.getNumberOfNodes(); i++) {
      myNodes[i].paint(g);
    }
    // draw messages in transition
    for (int i = 0; i < cg.dimension; i++) {
      Vector outgoingBuffers;
      outgoingBuffers = algorithm.getOutgoingBuffers(i);
      for (int j = 0; j < outgoingBuffers.size(); j++) {
        Vector buffer = (Vector)outgoingBuffers.elementAt(j);
        count = 0;
        for (int k = 0; k < buffer.size(); k++) {
          BasicMessage message = (BasicMessage)buffer.elementAt(k);
          // draw arrow 
          paintMessage(g, message);
        }
      }
    }
  }
  
  Koord msgdir;
  public void paintMessage(Graphics g, BasicMessage m) {
//    MessageRepresentation mr;
    Koord k0, k1, k2, spitze1, spitze2, kdir;
//    atobcount = btoacount = 0;
//    Enumeration iter = msgreps.elements();
//    while (iter.hasMoreElements()) {

//    mr   = (MessageRepresentation)iter.nextElement();
    k0 = calculate_koord(m);
    
    k1 = new Koord((int) ( nv.x * defaultlength) + k0.x, (int) (nv.y * defaultlength) + k0.y);
    k2 = new Koord((int) ( nv.x * defaultlength * spitzen_faktor) + k0.x,
                        (int) ( nv.y * defaultlength * spitzen_faktor) + k0.y);
    spitze1 = new Koord((int) ( nv.y * defaultlength * dist_faktor)    + k2.x,
                        (int) (-nv.x * defaultlength * dist_faktor)    + k2.y);
    spitze2 = new Koord((int) (-nv.y * defaultlength * dist_faktor)    + k2.x,
                        (int) ( nv.x * defaultlength * dist_faktor)    + k2.y);
   
    g.setColor(((Message)m).getColor());
    g.drawLine(k0.x, k0.y, k1.x, k1.y);
    g.drawLine(spitze1.x, spitze1.y, k1.x, k1.y);
    g.drawLine(spitze2.x, spitze2.y, k1.x, k1.y);
    if (m.label != null) g.drawString (m.label, k0.x, k0.y);
  }
  
  public Koord calculate_koord(BasicMessage m) { // always has to be called before calculate_direction
    GraphNode from = myNodes[m.source.nodeNumber];
    GraphNode to   = myNodes[m.destination.nodeNumber];
    if (m.source.nodeNumber == 1 && m.destination.nodeNumber == 0) {
      int z = 1;
    }
    Koord fromk, tok;
    int edgedist = 15;
    int actedgedist;

    fromk = new Koord(from.getkoord().x + from.getdim().x / 2, from.getkoord().y + from.getdim().y / 2);
    tok   = new Koord(to.getkoord().x + to.getdim().x / 2, to.getkoord().y + to.getdim().y / 2);
    count++;
    if (from == to) {
      fromk = new Koord(tok.x + 50, tok.y);
      tok   = new Koord(to.getkoord().x + to.getdim().x / 2, to.getkoord().y + to.getdim().y / 2);
    }
    nv = new NormVec (fromk, tok);
    double distance = nv.l * 0.3; // which offset from from-node to be drawn
    Koord k1 = new Koord((int)(nv.x * distance) + fromk.x, 
		         (int)(nv.y * distance) + fromk.y);
    // Calculate the individual distance from the connection
    actedgedist = edgedist * count; 
    Koord msgkoord = new Koord ((int)(-nv.y * actedgedist)   + k1.x,
			        (int)( nv.x * actedgedist)   + k1.y);
          msgdir   = new Koord ((int)( nv.x * actedgedist * 2) + msgkoord.x,  
			        (int)( nv.y * actedgedist * 2) + msgkoord.y);
    return msgkoord;
  }

  public int getnodehandle(Koord k) {
    for (int i = 0; i < algorithm.getNumberOfNodes(); i++) 
      if (myNodes[i].is_in(k)) return i;
    return -1;
  }

   public void newkoord(int handle, Koord k) throws ArrayIndexOutOfBoundsException {
     if (handle > myNodes.length) throw new ArrayIndexOutOfBoundsException();
   myNodes[handle].setkoord(k); 
  }

  public void invertnode(int handle) throws ArrayIndexOutOfBoundsException {
    if (handle > myNodes.length) throw new ArrayIndexOutOfBoundsException();
      myNodes[handle].invert(); 
  }
  
  public boolean doubleclick_action(int nodehandle, int count) throws ArrayIndexOutOfBoundsException {
    if (nodehandle > myNodes.length) throw new ArrayIndexOutOfBoundsException();
    return myNodes[nodehandle].doubleclick_action(count); 
  }
  
  class NormVec {
    double x, y, l;
    
    NormVec(Koord k0, Koord k1) {
      x = k1.x - k0.x;
      y = k1.y - k0.y;
      l = (int) Math.sqrt (Math.pow (x, 2) + Math.pow (y, 2));
      x /= l;
      y /= l;
    }
    
    public void print(String string) {
      SystemPrinter.println(string + ": x = " + x + ", " + y);
    }
  }
}