import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Rectangle;

/**
 *  Description of the Class
 *
 *@author     administrator
 *@created    31. Januar 2001
 */
public class GraphNode {
	Koord mykoord;
	Koord dim;
	String mylabel;
	// protected DNodeComment mycomment;

	Color defaultcolor = Color.white;
	//normal state
	Color invertcolor = Color.blue;
	//if i'm clicked
	Color initiatorcolor = Color.yellow;
	//if i'm initiator
	Color actcolor;
	//actual state to be painted
	Color mymsgcolor = Color.blue;
	//my messages... if the messages don't get the choice


	// k is Coord, d is height and width
	/**
	 *  Constructor for the GraphNode object
	 *
	 *@param  n  Description of Parameter
	 *@param  k  Description of Parameter
	 *@param  d  Description of Parameter
	 */
	public GraphNode(int n, Koord k, Koord d) {
		// super(n);
		mylabel = String.valueOf(n + 1);
		mykoord = (Koord) k.clone();
		dim = (Koord) d.clone();
		// mylabel  = new String ("" + mynumber);
		actcolor = defaultcolor;
	}


	/**
	 *  Constructor for the GraphNode object
	 *
	 *@param  n  Description of Parameter
	 */
	public GraphNode(int n) {
		this(n, new Koord(25 * n, (5 + n) * n), new Koord(20, 20));
	}


	/**
	 *  Description of the Method
	 *
	 *@param  c  Description of Parameter
	 */
	public void set_color(Color c) {
		actcolor = defaultcolor = c;
	}


	/**
	 *  Description of the Method
	 *
	 *@param  x  Description of Parameter
	 */
	public void setx(int x) {
		mykoord.x = x;
		notify_koords();
	}


	/**
	 *  Description of the Method
	 *
	 *@param  y  Description of Parameter
	 */
	public void sety(int y) {
		mykoord.y = y;
		notify_koords();
	}


	/**
	 *  Description of the Method
	 *
	 *@param  k  Description of Parameter
	 */
	public void setkoord(Koord k) {
		mykoord.x = k.x;
		mykoord.y = k.y;
		notify_koords();
	}


	/**
	 *  Description of the Method
	 *
	 *@param  d  Description of Parameter
	 */
	public void setdim(Koord d) {
		dim.x = d.x;
		dim.y = d.y;
	}


	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public int getx() {
		return mykoord.x;
	}


	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public int gety() {
		return mykoord.y;
	}


	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public Koord getkoord() {
		return mykoord;
	}


	/**
	 *  Description of the Method
	 *
	 *@return    Description of the Returned Value
	 */
	public Koord getdim() {
		return dim;
	}


	/**
	 *  Description of the Method
	 *
	 *@param  k  Description of Parameter
	 *@return    Description of the Returned Value
	 */
	public boolean is_in(Koord k) {
		Rectangle r = new Rectangle(mykoord.x, mykoord.y, dim.x, dim.y);
		return (r.contains(k.x, k.y));
	}


	/**
	 *  Description of the Method
	 */
	public void be_initiator() {
		//override the HistoryNode.be_initiator()
		// super.be_initiator();
		defaultcolor = initiatorcolor;
	}


	/**
	 *  Description of the Method
	 *
	 *@param  g  Description of Parameter
	 */
	public void paint(Graphics g) {
		FontMetrics fm = g.getFontMetrics();
		g.setColor(actcolor);
		g.fillRect(mykoord.x, mykoord.y, dim.x, dim.y);
		g.setColor(Color.black);
		g.drawRect(mykoord.x, mykoord.y, dim.x, dim.y);
		g.drawString(mylabel,
				mykoord.x + (dim.x - fm.stringWidth(mylabel)) / 2,
				mykoord.y + (dim.y + fm.getAscent()) / 2);
	}


	/**
	 *  Description of the Method
	 */
	public void invert() {
		if (actcolor == defaultcolor) {
			actcolor = invertcolor;
		}
		else {
			actcolor = defaultcolor;
		}
	}


	/*
	 * public void set_commentator(DNodeComment d) {
	 * mycomment = d;
	 * }
	 */

	/**
	 *  Description of the Method
	 *
	 *@param  count  Description of Parameter
	 *@return        Description of the Returned Value
	 */
	public boolean doubleclick_action(int count) {
		be_initiator();
		return true;
	}


	/**
	 *  Description of the Method
	 */
	private void notify_koords() {
		// if (mycomment != null) {mycomment.notify_koords (mykoord, dim);}
	}

}
