import java.awt.*;
import java.io.*;

public class GridMessage {
  HistoryNode from;
  HistoryNode to;
  public int sendingTime; 
  Color mycolor;
  Color defaultcolor = Color.blue;
  
  public GridMessage(HistoryNode a, HistoryNode b){
    mycolor = defaultcolor;
    from = (HistoryNode) a;
    to = (HistoryNode) b;
  }

  public void setColor(Color c) {
    mycolor=c;
  }
  
  // Paint a Message
  public void paint(Graphics g){
    g.setColor(mycolor);
    g.drawLine(from.getX(),from.getY(),to.getX(),to.getY());
  }
  
  public void printGraphic(PrintWriter tmp) {
    System.out.println("printing GridMessage " + mycolor);
    String color = "Blau";
    if (mycolor == Color.red) color = "Rot";
    else if (mycolor == Color.magenta) color = "Magenta";
    else if (mycolor == Color.yellow) color = "Gelb";
    else if (mycolor == Color.cyan) color = "Cyan";
    else if (mycolor == Color.green) color = "Gr\\x9f n";
    tmp.println(" <PolyLine ");
    tmp.println("  <Unique 105694>");
    tmp.println("  <Pen 0>");
    tmp.println("  <PenWidth 2.0 pt>");
    tmp.println("  <Separation 0>");
    tmp.println("  <ObColor `" + color + "'>");
    tmp.println("  <DashedPattern ");
    tmp.println("   <DashedStyle Solid >");
    tmp.println("  > # end of DashedPattern");
    tmp.println("  <HeadCap Square >");
    tmp.println("  <TailCap Square >");
    tmp.println("  <Overprint No >");
    tmp.println("  <NumPoints 2>");
    tmp.println("  <Point  " + from.getX() + "pt "
			     + from.getY() + "pt>");
    tmp.println("  <Point  " + to.getX() + "pt "
			     + to.getY() + "pt>");
    tmp.println(" > # end of PolyLine");
  }
}
