
import java.awt.*;
import java.awt.event.*;

// HistoryFrame is the class that instantiates the Frame containing the ScrollRep.
public class HistoryFrame extends Frame implements ActionListener {
  ScrollHistory pane;

  public HistoryFrame(Algorithm sm) {
    super("History");
    MenuBar mb = new MenuBar();
    Menu file = new Menu("File", true);
    file.add("Close");
    mb.add(file);
    file.addActionListener(this);
    setMenuBar(mb);
    pane = new ScrollHistory(sm);
    add (pane);
    this.setSize(500,500);
    this.setLocation(500, 0);
    this.show();
  } 

  // wait for an event (Next HistoryRound) and call the method
  // notifyNextRound() for the ScrollRep
  public void notifyNextTimestep() {
    pane.notifyNextTimestep();
  }
  
  /** overriding the method of ActionListener */  
  public void actionPerformed(ActionEvent e) {
    String c = e.getActionCommand();
    if (c == "Close")
      {
	dispose();
      }     
  }
  /** Calls the paint() method for ScrollRep */
  public void paint(Graphics g) {
    pane.paint(g);
  }
  
  public void printGraphic() {
    pane.printGraphic();
  } 
}

