import java.awt.*;
import java.io.*;

public class HistoryRound {
  int mynumber;
  HistoryNode[] mynodes;
  GridMessage[] mymessages;
  static int numberOfNodes;
  int[] decision;
  
  // This constructor is called for the first round: it gets no message
  //   i          my round number
  //   nb         number of nodes
  //   decision   vector of colors for painting mpublic HistoryRound(int i,int nb,int[] decision)t nb, int[] decision) {
  public HistoryRound(int i, int nb, int[] decision) {
    this.mynodes = new HistoryNode[nb];
    numberOfNodes = nb;
    this.decision = new int[numberOfNodes];
    for (int j = 0; j < numberOfNodes; j++) {
	this.mynodes[j] = new HistoryNode(j);
    }
    mynumber = i;
    for (int j = 0; j < numberOfNodes; j++) {
      this.decision[j] = decision[j];
    }
  }
  
  // This constructor is called for every round except the first one
  //   i         my round nummber
  public HistoryRound(int i, GridMessage[] messages, int[] decision) {
    this.mynodes = new HistoryNode[numberOfNodes];
    this.decision = new int[numberOfNodes];
    for (int j = 0; j < numberOfNodes; j++) {
	this.mynodes[j] = new HistoryNode(j);
      }
    mymessages = messages;
    mynumber = i;
    for (int j = 0; j < numberOfNodes; j++) {
      this.decision[j] = decision[j];
    }
  }
 
  // Get the number of the round
  public int getnumber() {
    return this.mynumber;
  }

  // painting the diagramm with nodes, grid of rounds, and messages
  public void paint(Graphics g) {
    // painting the nodes before the first round
    if (this.mynumber == 0){
      for(int i = 0 ; i < mynodes.length ; i++) {
	mynodes[i].paint(g);
      }
    } else{
      // painting the messages of this round
      ((Graphics2D)g).setStroke(new BasicStroke(2));
      for(int j = 0 ; j < mymessages.length; j++){
	mymessages[j].paint(g);
      }
      ((Graphics2D)g).setStroke(new BasicStroke(1));
    }
    // drawing horizontal grid line
    g.setColor(Color.black);
    g.drawLine(this.mynodes[0].getX(),
	       this.mynodes[0].getY(),
	       this.mynodes[mynodes.length - 1].getX(),
	       this.mynodes[mynodes.length - 1].getY());
  }

  // Output the drawing in Framemaker MIF format
  public void printGraphic(PrintWriter tmp) {
    if (this.mynumber == 0){
      for(int i = 0 ; i < mynodes.length ; i++) {
	mynodes[i].printGraphic(tmp);
      }
    } else{
      for(int j = 0 ; j < mymessages.length; j++){
	mymessages[j].printGraphic(tmp);
      }
    }
    tmp.println(" <PolyLine ");
    tmp.println("  <Unique 105694>");
    tmp.println("  <Pen 0>");
    tmp.println("  <PenWidth 1.0 pt>");
    tmp.println("  <Separation 0>");
    tmp.println("  <ObColor `Schwarz'>");
    tmp.println("  <DashedPattern ");
    tmp.println("   <DashedStyle Solid >");
    tmp.println("  > # end of DashedPattern");
    tmp.println("  <HeadCap Square >");
    tmp.println("  <TailCap Square >");
    tmp.println("  <Overprint No >");
    tmp.println("  <NumPoints 2>");
    tmp.println("  <Point  " + this.mynodes[0].getX() + "pt "
			     + this.mynodes[0].getY() + "pt>");
    tmp.println("  <Point  " + this.mynodes[mynodes.length - 1].getX() + "pt "
			     + this.mynodes[mynodes.length - 1].getY() + "pt>");
    tmp.println(" > # end of PolyLine");
  }
}
