import java.awt.*;
import java.util.*;

import scheduler.*;
import sysPr.*;

public abstract class SimProcess extends Thread {
  Scheduler scheduler;
  int uniqueID = 1;
  int nodeNumber;
  Vector outgoingConnections = new Vector();
  Vector incomingConnections = new Vector();
  Semaphore messageArrived;
  int receiveTurn;    // Number of next connection to be searched for messages
  double time;        // Local time
  
  public SimProcess(String name, Scheduler scheduler, int nodeNumber) {
    this.scheduler = scheduler;
    setName(name);
    this.nodeNumber = nodeNumber;
    messageArrived = new Semaphore("RG ", 0, scheduler);
    time = nodeNumber / 100.0;
//    SystemPrinter.println("initial time = " + time);
    receiveTurn = 0;
  }
      
  public void addConnection(SimProcess destination) {
    Connection connection = new Connection(this, destination, destination.messageArrived);
    outgoingConnections.addElement(connection);
    destination.incomingConnections.addElement(connection);
  }
  
  public void deleteConnection(SimProcess destination) {
    for (int i = 0; i < outgoingConnections.size(); i++) {
      if (((Connection)(outgoingConnections.elementAt(i))).destination == destination) {
        outgoingConnections.remove(i);
        break;
      }
    }
  }
  
  Message receive() {
    int counter = 0;
    BasicMessage message = null;
    Vector buffer = new Vector();
    // SystemPrinter.println("requesting receiveGroup");
    messageArrived.p();
    // SystemPrinter.println("Message received");
    while (true) {
      if ((buffer = (((Connection)
		      (incomingConnections.elementAt(receiveTurn))
		     )
		    ).buffer
	  ).size()
	  != 0) {
	if ((message = (BasicMessage)(buffer.elementAt(0))) != null) {
	  if (message.deliveringTime <= ((Algorithm)(scheduler.system)).getSimulationTime()) {
	    message = ((BasicConnection)(incomingConnections.elementAt(receiveTurn))).receive();
	    // enque received message into message queue of Algorithm
            // SystemPrinter.println("***** enqueue message");
	    ((Algorithm)(scheduler.system)).enqueue((Message)message);
	    return (Message)message;
	  }
	}
      }
      receiveTurn = (receiveTurn + 1) % incomingConnections.size();
      if (++counter == incomingConnections.size()) {
	counter = 0;
	// SystemPrinter.println("awaiting message");
	scheduler.schedule();
      }
    }
  } 
    
  public void run () {
    scheduler.schedule();
    scheduler.sleep(1000);
    runProcess();
    scheduler.sleep(10000);
    scheduler.eliminateThread(this);
  }
  
  public abstract void runProcess();
  
  public double incrementTime() {
    return time++;
  }  
  
  public double getTime() {
    return time;
  }  

  public void setTime(double f_time) {
    time = f_time;
  }  
}

